ClassHolder = class( Turbine.UI.Control );
function ClassHolder:Constructor()
	Turbine.UI.Control.Constructor( self );
	self:SetSize(282, 59);
	self.scaleModifier = Settings["General"]["Scale"]/100;

	self.player = Turbine.Gameplay.LocalPlayer.GetInstance();
	self.playerAttributes = self.player:GetClassAttributes();

	self.frame = Turbine.UI.Control();
	self.frame:SetParent( self );
	self.frame:SetBackground( "ExoPlugins/Athelas/Resources/resourceframe.tga" );
	self.frame:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply );
	self.frame:SetSize(282, 59);
	self.frame:SetVisible(true);
	self.frame:SetMouseVisible(false);
	self.frame:SetZOrder(95);

	local class = GetClass(self.player);
	self.effectsCallback = {};
	self.attributesCallback = {};
	self.timer = 0;

	Turbine.UI.Lotro.LotroUI.SetEnabled(19, false);

	if class == "Runekeeper" then
		self.resource = ResourceBar(self, 180, 20, 9, "ExoPlugins/Athelas/Resources/dagor.tga");
		self.resource:SetPosition(51, 16);
		self.resource:SetAttunementTotal(self.playerAttributes:GetAttunement());

		self.attributesCallback["AttunementChanged"] = AddCallback(self.playerAttributes, "AttunementChanged", function(sender, args)
			self.resource:SetAttunementTotal(self.playerAttributes:GetAttunement());
			self:ResourceChanged();
		end);
	elseif class == "Brawler" then
		self.resource = ResourceBar(self, 180, 20, 9, "ExoPlugins/Athelas/Resources/mettle.tga");
		self.resource:SetPosition(51, 16);
		self.resource:SetTotal(0);

		self.BattleFlow = {
			["Battle Flow 1"] = 1,
			["Battle Flow 2"] = 2,
			["Battle Flow 3"] = 3,
			["Battle Flow 4"] = 4,
			["Battle Flow 5"] = 5,
			["Battle Flow 6"] = 6,
			["Battle Flow 7"] = 7,
			["Battle Flow 8"] = 8,
			["Battle Flow 9"] = 9,
		};
		self.lastTier = "Battle Flow 1";

		self.playerEffects = self.player:GetEffects();

		self.effectsCallback["EffectAdded"] = AddCallback(self.playerEffects, "EffectAdded", function(sender, args)
			local effectName = self.playerEffects:Get(args.Index):GetName();
			if self.BattleFlow[effectName] ~= nil then
				self.lastTier = effectName;
				self.resource:SetTotal(self.BattleFlow[effectName]);
				self:ResourceChanged();
			end
		end);

		self.effectsCallback["EffectRemoved"] = AddCallback(self.playerEffects, "EffectRemoved", function(sender, args)
			local effect = args.Effect;
			if effect ~= nil then 
				local effectName = effect:GetName();
				if effectName == self.lastTier then
					self.resource:SetTotal(0);
					self:ResourceChanged();
				end
			end
		end);

	elseif class == "Hunter" then
		self.resource = ResourceBar(self, 180, 20, 9, "ExoPlugins/Athelas/Resources/focus.tga");
		self.resource:SetPosition(51, 16);
		self.resource:SetTotal(self.playerAttributes:GetFocus());

		self.attributesCallback["FocusChanged"] = AddCallback(self.playerAttributes, "FocusChanged", function(sender, args)
			self.resource:SetTotal(self.playerAttributes:GetFocus());
			self:ResourceChanged();
		end);
	elseif class == "Champion" then
		self.resource = ResourceBar(self, 180, 20, 5, "ExoPlugins/Athelas/Resources/fervor.tga");
		self.resource:SetPosition(51, 16);
		self.resource:SetTotal(self.playerAttributes:GetFervor());

		self.attributesCallback["FervorChanged"] = AddCallback(self.playerAttributes, "FervorChanged", function(sender, args)
			self.resource:SetTotal(self.playerAttributes:GetFervor());
			self:ResourceChanged();
		end);
	elseif class == "Warden" then
		self.resource = ResourceBar(self, 180, 20, 5, "ExoPlugins/Athelas/Resources/empty.tga");
		self.resource:SetPosition(51, 16);
		self.resource:ConfigureGambitInfo(self.playerAttributes);
		self.attributesCallback["GambitChanged"] = AddCallback(self.playerAttributes, "GambitChanged", function(sender, args)
			self.resource:AdjustGambitDisplay();
			self:ResourceChanged();
		end);
	
	elseif class == "Mariner" then
		self.colours = {
			[0] = Turbine.UI.Color(0,0.36,0.91),
			[1] = Turbine.UI.Color(0.13,0.6,0.69),
			[2] = Turbine.UI.Color(0,1,0.05),
			[3] = Turbine.UI.Color(1,0.5,0.15),
			[4] = Turbine.UI.Color(0.92,0.11,0.14),
		};
		self.resource = BalanceBar(self, 160, 12, self.colours, 10);
		self.resource:SetTotal(self.playerAttributes:GetBalance());
		self.attributesCallback["BalanceChanged"] = AddCallback(self.playerAttributes, "BalanceChanged", function(sender, args)
			self.resource:SetTotal(self.playerAttributes:GetBalance());
			self:ResourceChanged();
		end);
	end
	self.CombatCallback = AddCallback(self.player, "InCombatChanged", function(sender, args)
		if self.player:IsInCombat() then self:SetActive(true) end
	end);

	self.updateCallback = AddCallback(Updater, "Tick", function(sender, args)
		if self.player:IsInCombat() then return end
		self.timer = self.timer + 0.5;
		if self.timer > Settings["Player"]["Resource"]["Timeout"] then
			self:SetActive(false);
		end
	end);

	self.lastTick = Turbine.Engine.GetGameTime();
	self.Update = function()
		if self:GetTop() == self.endPoint then self:SetWantsUpdates(false) return end
        if Turbine.Engine.GetGameTime() - self.lastTick < 0.05 then return end
		self:SetTop(self:GetTop() + self.direction);
    end
	if self.resource ~= nil then
		self.resource:SetStretchMode(1);
		self.resource:SetSize(math.ceil(180*self.scaleModifier), math.ceil(20*self.scaleModifier));
		self.resource:SetPosition(math.ceil(51*self.scaleModifier), math.ceil(16*self.scaleModifier));
	end
	self.frame:SetStretchMode(1);
	self.frame:SetSize(math.ceil(282*self.scaleModifier), math.ceil(59*self.scaleModifier));
end

function ClassHolder:SetActive(bool)
	if bool then
		self.endPoint = math.floor(33-math.ceil(33*self.scaleModifier));
		self.direction = -1;
	else
		self.endPoint = math.floor(math.ceil(33*self.scaleModifier)+((1-self.scaleModifier)*10*2));
		self.direction = 1;
	end
	self:SetWantsUpdates(true);
end

function ClassHolder:ResourceChanged()
	self.timer = 0;
	self:SetActive(true);
end

function ClassHolder:Unload()
	for key, value in pairs(self.attributesCallback) do
        RemoveCallback(self.playerAttributes, key, value);
        self.attributesCallback[key] = nil;
    end
	for key, value in pairs(self.effectsCallback) do
        RemoveCallback(self.playerEffects, key, value);
        self.effectsCallback[key] = nil;
    end
	RemoveCallback(Updater, "Tick", self.updateCallback);
	self.resource:Unload();
	self.frame = nil;
	self = nil;
end

ResourceBar = class( Turbine.UI.Control );
function ResourceBar:Constructor(parent, width, height, pipCount, icon)
    Turbine.UI.Control.Constructor( self );
    self:SetParent(parent);
    self:SetSize(width, height);
    self:SetZOrder(100);
    self:SetMouseVisible(false);
    self:SetVisible(true);

    self.pipCount = pipCount;
    self.Pips = {};

    for i = 1, self.pipCount, 1 do
        self.Pips[i] = Pip(self, 20, 20)
        self.Pips[i]:SetPosition((width/2) - ((20/2) * pipCount) + ((i-1)*20), 0);
		self.Pips[i]:SetBackground( icon )
		self.Pips[i]:SetStretchMode(1);
    end
end

function ResourceBar:SetTotal(total)
    for i = 1, self.pipCount, 1 do
        if i <= total then
			self.Pips[i]:SetVisible(true);
        else
            self.Pips[i]:SetVisible(false);
        end
    end
end

function ResourceBar:SetAttunementTotal(total)
    local currentTotal = (total - 10);
	local background = "ExoPlugins/Athelas/Resources/nestad.tga";
	if currentTotal < 0 then
        currentTotal = currentTotal * -1;
		background = "ExoPlugins/Athelas/Resources/dagor.tga";
    end

	for i = 1, self.pipCount, 1 do
        if i <= currentTotal then
            self.Pips[i]:SetBackground(background);
			self.Pips[i]:SetVisible(true);
        else
            self.Pips[i]:SetVisible(false);
        end
    end
end

function ResourceBar:ConfigureGambitInfo(player)
	self.player = player;
	self.gambitIcons = {
		[0] = "ExoPlugins/Athelas/Resources/empty.tga",
		[1] = "ExoPlugins/Athelas/Resources/spear.tga",
		[2] = "ExoPlugins/Athelas/Resources/shield.tga",
		[3] = "ExoPlugins/Athelas/Resources/fist.tga",
	};
	for i = 1, self.pipCount, 1 do
        self.Pips[i] = Pip(self, 25, 25)
        self.Pips[i]:SetPosition((180/2) - ((25/2) * self.pipCount) + ((i-1)*25), -2);
		self.Pips[i]:SetStretchMode(0);
		self.Pips[i]:SetBackground( icon )
		self.Pips[i]:SetStretchMode(1);
    end
	self:AdjustGambitDisplay();
end

function ResourceBar:AdjustGambitDisplay()
	for i = 1, self.pipCount, 1 do
		self.Pips[i]:SetBackground(self.gambitIcons[self.player:GetGambit(i)]);
    end
end

function ResourceBar:Unload()
    for i = 1, self.pipCount, 1 do
        self.Pips[i]:Unload();
    end
    self.Pips = {};
    self:SetParent(nil);
	self = nil;
end

Pip = class( Turbine.UI.Control );
function Pip:Constructor(parent, width, height)
    Turbine.UI.Control.Constructor( self );
    self:SetParent(parent);
    self:SetSize(width, height);
    self:SetZOrder(100);
    self:SetMouseVisible(false);
    self:SetVisible(true);
end

function Pip:Unload()
	self = nil;
end


BalanceBar = class( Turbine.UI.Control );
function BalanceBar:Constructor(parent, width, height, colours, pointerScale)
    Turbine.UI.Control.Constructor( self );
    self:SetParent(parent);
    self:SetSize(width, height);
    self:SetZOrder(100);
    self:SetMouseVisible(false);
    self:SetVisible(true);

    self.colours = colours;
    self.pointerScale = pointerScale;

    --Example settings. Requires a value stored at 0 to be the default colour, other values are break points that tell it to switch to a new colour
    --In this example 0-2 pips are blue, 3-8 pips are yellow, and 9 pips display as red.

    --[[self.colours = {
    [0] = Turbine.UI.Color(0.23, 0.12, 0.77),
    [3] = Turbine.UI.Color( 1.00, 0.96, 0.41 ),
    [9] = Turbine.UI.Color(0.77, 0.12, 0.23),
    };]]--
    self.BorderBox = Turbine.UI.Control();
    self.BorderBox:SetParent(self);
    self.BorderBox:SetSize(width, height);
    self.BorderBox:SetPosition(0, 0);
    self.BorderBox:SetBackColor(Turbine.UI.Color.Black);

    local valueWidth = width-2;

    self.SegmentOneBackground = Turbine.UI.Control();
    self.SegmentOneBackground:SetParent(self.BorderBox);
    self.SegmentOneBackground:SetSize((7/50)*valueWidth, height - 2);
    self.SegmentOneBackground:SetPosition(1, 1);
    self.SegmentOneBackground:SetMouseVisible(false);
    self.SegmentOneBackground:SetBackColor(self.colours[0]);
    --| 0-6 | 7-18 | 19-31 | 32-43 | 44-50 |
    --0     7      20      30      43      50
    --+1     +2     +3      +4      +5


    self.SegmentOneDivider = Turbine.UI.Control();
    self.SegmentOneDivider:SetParent(self.BorderBox);
    self.SegmentOneDivider:SetSize(1, height - 2);
    self.SegmentOneDivider:SetPosition(1+(7/50)*valueWidth, 1);
    self.SegmentOneDivider:SetMouseVisible(false);
    self.SegmentOneDivider:SetBackColor(Turbine.UI.Color.Black);

    self.SegmentTwoBackground = Turbine.UI.Control();
    self.SegmentTwoBackground:SetParent(self.BorderBox);
    self.SegmentTwoBackground:SetSize((14/50)*valueWidth, height - 2);
    self.SegmentTwoBackground:SetPosition(self.SegmentOneDivider:GetLeft()+1, 1);
    self.SegmentTwoBackground:SetMouseVisible(false);
    self.SegmentTwoBackground:SetBackColor(self.colours[1]);

    self.SegmentTwoDivider = Turbine.UI.Control();
    self.SegmentTwoDivider:SetParent(self.BorderBox);
    self.SegmentTwoDivider:SetSize(1, height - 2);
    self.SegmentTwoDivider:SetPosition(1+(19/50)*valueWidth, 1);
    self.SegmentTwoDivider:SetMouseVisible(false);
    self.SegmentTwoDivider:SetBackColor(Turbine.UI.Color.Black);

    self.SegmentThreeBackground = Turbine.UI.Control();
    self.SegmentThreeBackground:SetParent(self.BorderBox);
    self.SegmentThreeBackground:SetSize((13/50)*valueWidth, height - 2);
    self.SegmentThreeBackground:SetPosition(self.SegmentTwoDivider:GetLeft()+1, 1);
    self.SegmentThreeBackground:SetMouseVisible(false);
    self.SegmentThreeBackground:SetBackColor(self.colours[2]);

    self.SegmentThreeDivider = Turbine.UI.Control();
    self.SegmentThreeDivider:SetParent(self.BorderBox);
    self.SegmentThreeDivider:SetSize(1, height - 2);
    self.SegmentThreeDivider:SetPosition(1+(31/50)*valueWidth, 1);
    self.SegmentThreeDivider:SetMouseVisible(false);
    self.SegmentThreeDivider:SetBackColor(Turbine.UI.Color.Black);

    self.SegmentFourBackground = Turbine.UI.Control();
    self.SegmentFourBackground:SetParent(self.BorderBox);
    self.SegmentFourBackground:SetSize((14/50)*valueWidth, height - 2);
    self.SegmentFourBackground:SetPosition(self.SegmentThreeDivider:GetLeft()+1, 1);
    self.SegmentFourBackground:SetMouseVisible(false);
    self.SegmentFourBackground:SetBackColor(self.colours[3]);

    self.SegmentFourDivider = Turbine.UI.Control();
    self.SegmentFourDivider:SetParent(self.BorderBox);
    self.SegmentFourDivider:SetSize(1, height - 2);
    self.SegmentFourDivider:SetPosition(1+(43/50)*valueWidth, 1);
    self.SegmentFourDivider:SetMouseVisible(false);
    self.SegmentFourDivider:SetBackColor(Turbine.UI.Color.Black);

    self.SegmentFiveBackground = Turbine.UI.Control();
    self.SegmentFiveBackground:SetParent(self.BorderBox);
    self.SegmentFiveBackground:SetSize((7/50)*valueWidth, height - 2);
    self.SegmentFiveBackground:SetPosition(self.SegmentFourDivider:GetLeft()+1, 1);
    self.SegmentFiveBackground:SetMouseVisible(false);
    self.SegmentFiveBackground:SetBackColor(self.colours[4]);

    self.pointer = Turbine.UI.Control();
    self.pointer:SetParent(self);
    self.pointer:SetSize(16, 20)
    self.pointer:SetBackground("ExoPlugins/Athelas/Resources/pointer.tga");
	self.pointer:SetStretchMode(1);
	self.pointer:SetBlendMode(4);
    self:SetTotal(0);
end

function BalanceBar:SetTotal(total)
    local valueWidth = self:GetWidth()-2;
    self.pointer:SetPosition(1+((total/50)*valueWidth)-16/2, -20/2+(self:GetHeight()/2));
end

function BalanceBar:Unload()
    self:SetParent(nil);
	self = nil;
end